package xyz.thastertyn.Window;

import java.util.concurrent.atomic.AtomicBoolean;

import com.googlecode.lanterna.TerminalPosition;
import com.googlecode.lanterna.TerminalSize;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.Window;
import com.googlecode.lanterna.gui2.WindowBasedTextGUI;
import com.googlecode.lanterna.gui2.WindowListener;
import com.googlecode.lanterna.input.KeyStroke;
import com.googlecode.lanterna.input.KeyType;

import xyz.thastertyn.Window.Content.JecnaContent;
import xyz.thastertyn.Window.Content.Rozvrh;
import xyz.thastertyn.Window.Content.Znamky;

public class WindowSwitchListener implements WindowListener {

	WindowBasedTextGUI gui;

	private JecnaContent[] contents = {new Rozvrh(), new Znamky()};

	private String JsessionId;

	Panel content;
	Panel tabs;

	String title;
	
	int current = 0;

	public WindowSwitchListener(Panel holder, String JsessionId, Panel tabs, String title)
	{
		this.content = holder;
		this.tabs = tabs;
		this.title = title;
		this.JsessionId = JsessionId;
		defaultPanel();
	}
	
	private void defaultPanel()
	{
		contents[0].download(JsessionId);
		content.removeAllComponents();
		content.addComponent(contents[0].getPanel());
		title = contents[0].getLabel();
	}

	public void next()
	{
		if(current + 1 == contents.length)
		{
			current = 0;
		}else{
			current++;
		}

		if(!contents[current].hasStarted())
		{
			contents[current].download(JsessionId);
		}

		content.removeAllComponents();
		content.addComponent(contents[current].getPanel());

		title = contents[current].getLabel();
	}

	public void previous()
	{
		if(current - 1 == -1)
		{
			current = contents.length - 1;
		}else{
			current--;
		}

		if(!contents[current].hasStarted())
		{
			contents[current].download(JsessionId);
		}
		content.removeAllComponents();
		content.addComponent(contents[current].getPanel());

		title = contents[current].getLabel();
	}


	
	@Override
	public void onInput(Window basePane, KeyStroke keyStroke, AtomicBoolean deliverEvent) {
		KeyType type = keyStroke.getKeyType();

		switch(type)
		{
			case Tab:
				if(!keyStroke.isShiftDown())
				{
					next();
				}else{
					previous();
				}
				break;
			default:
				break;
		}
	}

	@Override
	public void onUnhandledInput(Window basePane, KeyStroke keyStroke, AtomicBoolean hasBeenHandled) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onResized(Window window, TerminalSize oldSize, TerminalSize newSize) {
		window.invalidate();
	}

	@Override
	public void onMoved(Window window, TerminalPosition oldPosition, TerminalPosition newPosition) {
		// TODO Auto-generated method stub
	}
	
}
